diff --git a/recipes/bzip2/bzip2-1.0.6/autoconfiscate.patch b/recipes/bzip2/bzip2-1.0.6/autoconfiscate.patch
index ad720b8..2bbf35e 100644
--- a/recipes/bzip2/bzip2-1.0.6/autoconfiscate.patch
+++ b/recipes/bzip2/bzip2-1.0.6/autoconfiscate.patch
@@ -1,135 +1,6 @@
-diff -urN files/autogen.sh ./autogen.sh
---- bzip2-1.0.5.orig/autogen.sh	1970-01-01 01:00:00.000000000 +0100
-+++ bzip2-1.0.5.autoconfiscated/autogen.sh	2009-11-06 12:10:43.574602171 +0100
-@@ -0,0 +1,8 @@
-+mv LICENSE COPYING
-+mv CHANGES NEWS
-+touch AUTHORS
-+touch ChangeLog
-+libtoolize --force
-+aclocal
-+automake --add-missing --gnu
-+autoconf
-diff -urN bzip2-1.0.5.orig/README.autotools bzip2-1.0.5.autoconfiscated/README.autotools
---- bzip2-1.0.5.orig/README.autotools	1970-01-01 01:00:00.000000000 +0100
-+++ bzip2-1.0.5.autoconfiscated/README.autotools	2009-11-05 23:06:27.000000000 +0100
-@@ -0,0 +1,39 @@
-+bzip2 autoconfiscated
-+=====================
-+
-+Temporarily at http://pack.suse.cz/sbrabec/bzip2/ expecting that it will
-+become a new upstream version to prevent per-distribution shared library
-+patching done by nearly each Linux vendor separately.
-+
-+Autoconfiscation brings standard ./configure ; make ; make install
-+installation, seamless support of DESTDIR, automatic check for supported
-+CFLAGS, standard shared library support, automatic large files CFLAGS
-+check and all things that are supported by automake.
-+
-+It makes obsolete Makefile-libbz2_so and README.COMPILATION.PROBLEMS.
-+Now configure should automatically detect correct build flags.
-+
-+In case of any problem or question with autotools support feel free to
-+contact me: Stanislav Brabec <sbrabec@suse.cz>
-+
-+Autoconfiscated version binaries are exactly equal to
-+bzip2-1.0.5.tar.gz. There are only few changes. See below.
-+
-+
-+New features:
-+
-+Trivial link man pages for bzcat and bunzip2 added.
-+
-+bzip2.pc file for pkg-config. Packages can use it for checks.
-+
-+
-+Incompatible changes:
-+
-+soname change. Libtool has no support for two parts name suffix (e. g.
-+libbz2.so.1.0). It must be a single number (e. g. libbz2.so.1). That is
-+why soname must change. But I see not a big problem with it. Several
-+distributions already use the new number instead of the non-standard
-+number from Makefile-libbz2_so.
-+
-+To be super-safe, I incremented minor number of the library file, so
-+both instances of the shared library can live together.
-diff -urN bzip2-1.0.5.orig/configure.ac bzip2-1.0.5.autoconfiscated/configure.ac
---- bzip2-1.0.5.orig/configure.ac	1970-01-01 01:00:00.000000000 +0100
-+++ bzip2-1.0.5.autoconfiscated/configure.ac	2009-11-06 17:04:04.000000000 +0100
-@@ -0,0 +1,70 @@
-+#                                               -*- Autoconf -*-
-+# Process this file with autoconf to produce a configure script.
-+
-+AC_PREREQ([2.57])
-+AC_INIT([bzip2], [1.0.5], [Julian Seward <jseward@bzip.org>])
-+BZIP2_LT_CURRENT=1
-+BZIP2_LT_REVISION=5
-+BZIP2_LT_AGE=0
-+AC_CONFIG_SRCDIR([bzlib.h])
-+AC_CONFIG_MACRO_DIR([m4])
-+
-+AM_INIT_AUTOMAKE
-+AM_MAINTAINER_MODE
-+
-+# Checks for programs.
-+AC_PROG_AWK
-+AC_PROG_CC
-+AC_PROG_INSTALL
-+AC_PROG_LN_S
-+AC_PROG_MAKE_SET
-+AC_PROG_LIBTOOL
-+PKG_PROG_PKG_CONFIG
-+
-+# Checks for libraries.
-+
-+# Checks for header files.
-+
-+# Checks for typedefs, structures, and compiler characteristics.
-+
-+# Check for system features.
-+AC_SYS_LARGEFILE
-+
-+AC_MSG_CHECKING([whether compiler understands -Wall])
-+save_CFLAGS="$CFLAGS"
-+CFLAGS="$CFLAGS -Wall"
-+AC_TRY_COMPILE([], [], [
-+	AC_MSG_RESULT([yes])
-+], [
-+	AC_MSG_RESULT([no])
-+	CFLAGS="$save_CFLAGS"
-+])
-+
-+AC_MSG_CHECKING([whether compiler understands -Winline])
-+save_CFLAGS="$CFLAGS"
-+CFLAGS="$CFLAGS -Winline"
-+AC_TRY_COMPILE([], [], [
-+	AC_MSG_RESULT([yes])
-+], [
-+	AC_MSG_RESULT([no])
-+	CFLAGS="$save_CFLAGS"
-+])
-+
-+AC_MSG_CHECKING([whether compiler understands -fno-strength-reduce])
-+save_CFLAGS="$CFLAGS"
-+CFLAGS="$CFLAGS -fno-strength-reduce"
-+AC_TRY_COMPILE([], [], [
-+	AC_MSG_RESULT([yes])
-+], [
-+	AC_MSG_RESULT([no])
-+	CFLAGS="$save_CFLAGS"
-+])
-+
-+# Checks for library functions.
-+
-+# Write the output.
-+AC_SUBST([BZIP2_LT_CURRENT])
-+AC_SUBST([BZIP2_LT_REVISION])
-+AC_SUBST([BZIP2_LT_AGE])
-+AC_CONFIG_FILES([Makefile bzip2.pc])
-+AC_OUTPUT
-diff -urN bzip2-1.0.5.orig/Makefile.am bzip2-1.0.5.autoconfiscated/Makefile.am
---- bzip2-1.0.5.orig/Makefile.am	1970-01-01 01:00:00.000000000 +0100
-+++ bzip2-1.0.5.autoconfiscated/Makefile.am	2009-11-05 16:45:11.000000000 +0100
+diff -urN bzip2-1.0.6/Makefile.am bzip2-1.0.6.mod/Makefile.am
+--- bzip2-1.0.6/Makefile.am	1970-01-01 01:00:00.000000000 +0100
++++ bzip2-1.0.6.mod/Makefile.am	2012-10-11 00:26:08.000000000 +0200
 @@ -0,0 +1,138 @@
 +lib_LTLIBRARIES = libbz2.la
 +
@@ -269,9 +140,64 @@ diff -urN bzip2-1.0.5.orig/Makefile.am bzip2-1.0.5.autoconfiscated/Makefile.am
 +	xmlproc.sh
 +
 +ACLOCAL_AMFLAGS = -I m4
-diff -urN bzip2-1.0.5.orig/bzip2.pc.in bzip2-1.0.5.autoconfiscated/bzip2.pc.in
---- bzip2-1.0.5.orig/bzip2.pc.in	1970-01-01 01:00:00.000000000 +0100
-+++ bzip2-1.0.5.autoconfiscated/bzip2.pc.in	2009-11-03 18:48:28.000000000 +0100
+diff -urN bzip2-1.0.6/README.autotools bzip2-1.0.6.mod/README.autotools
+--- bzip2-1.0.6/README.autotools	1970-01-01 01:00:00.000000000 +0100
++++ bzip2-1.0.6.mod/README.autotools	2012-10-11 00:26:08.000000000 +0200
+@@ -0,0 +1,39 @@
++bzip2 autoconfiscated
++=====================
++
++Temporarily at http://pack.suse.cz/sbrabec/bzip2/ expecting that it will
++become a new upstream version to prevent per-distribution shared library
++patching done by nearly each Linux vendor separately.
++
++Autoconfiscation brings standard ./configure ; make ; make install
++installation, seamless support of DESTDIR, automatic check for supported
++CFLAGS, standard shared library support, automatic large files CFLAGS
++check and all things that are supported by automake.
++
++It makes obsolete Makefile-libbz2_so and README.COMPILATION.PROBLEMS.
++Now configure should automatically detect correct build flags.
++
++In case of any problem or question with autotools support feel free to
++contact me: Stanislav Brabec <sbrabec@suse.cz>
++
++Autoconfiscated version binaries are exactly equal to
++bzip2-1.0.5.tar.gz. There are only few changes. See below.
++
++
++New features:
++
++Trivial link man pages for bzcat and bunzip2 added.
++
++bzip2.pc file for pkg-config. Packages can use it for checks.
++
++
++Incompatible changes:
++
++soname change. Libtool has no support for two parts name suffix (e. g.
++libbz2.so.1.0). It must be a single number (e. g. libbz2.so.1). That is
++why soname must change. But I see not a big problem with it. Several
++distributions already use the new number instead of the non-standard
++number from Makefile-libbz2_so.
++
++To be super-safe, I incremented minor number of the library file, so
++both instances of the shared library can live together.
+diff -urN bzip2-1.0.6/autogen.sh bzip2-1.0.6.mod/autogen.sh
+--- bzip2-1.0.6/autogen.sh	1970-01-01 01:00:00.000000000 +0100
++++ bzip2-1.0.6.mod/autogen.sh	2012-10-11 00:44:14.000000000 +0200
+@@ -0,0 +1,8 @@
++mv LICENSE COPYING
++mv CHANGES NEWS
++touch AUTHORS
++touch ChangeLog
++$LIBTOOLIZE --force
++aclocal
++automake --add-missing --gnu
++autoreconf
+diff -urN bzip2-1.0.6/bzip2.pc.in bzip2-1.0.6.mod/bzip2.pc.in
+--- bzip2-1.0.6/bzip2.pc.in	1970-01-01 01:00:00.000000000 +0100
++++ bzip2-1.0.6.mod/bzip2.pc.in	2012-10-11 00:26:08.000000000 +0200
 @@ -0,0 +1,11 @@
 +prefix=@prefix@
 +exec_prefix=@exec_prefix@
@@ -284,3 +210,77 @@ diff -urN bzip2-1.0.5.orig/bzip2.pc.in bzip2-1.0.5.autoconfiscated/bzip2.pc.in
 +Version: @VERSION@
 +Libs: -L${libdir} -lbz2
 +Cflags: -I${includedir}
+diff -urN bzip2-1.0.6/configure.ac bzip2-1.0.6.mod/configure.ac
+--- bzip2-1.0.6/configure.ac	1970-01-01 01:00:00.000000000 +0100
++++ bzip2-1.0.6.mod/configure.ac	2012-10-11 00:26:08.000000000 +0200
+@@ -0,0 +1,70 @@
++#                                               -*- Autoconf -*-
++# Process this file with autoconf to produce a configure script.
++
++AC_PREREQ([2.57])
++AC_INIT([bzip2], [1.0.5], [Julian Seward <jseward@bzip.org>])
++BZIP2_LT_CURRENT=1
++BZIP2_LT_REVISION=5
++BZIP2_LT_AGE=0
++AC_CONFIG_SRCDIR([bzlib.h])
++AC_CONFIG_MACRO_DIR([m4])
++
++AM_INIT_AUTOMAKE
++AM_MAINTAINER_MODE
++
++# Checks for programs.
++AC_PROG_AWK
++AC_PROG_CC
++AC_PROG_INSTALL
++AC_PROG_LN_S
++AC_PROG_MAKE_SET
++AC_PROG_LIBTOOL
++PKG_PROG_PKG_CONFIG
++
++# Checks for libraries.
++
++# Checks for header files.
++
++# Checks for typedefs, structures, and compiler characteristics.
++
++# Check for system features.
++AC_SYS_LARGEFILE
++
++AC_MSG_CHECKING([whether compiler understands -Wall])
++save_CFLAGS="$CFLAGS"
++CFLAGS="$CFLAGS -Wall"
++AC_TRY_COMPILE([], [], [
++	AC_MSG_RESULT([yes])
++], [
++	AC_MSG_RESULT([no])
++	CFLAGS="$save_CFLAGS"
++])
++
++AC_MSG_CHECKING([whether compiler understands -Winline])
++save_CFLAGS="$CFLAGS"
++CFLAGS="$CFLAGS -Winline"
++AC_TRY_COMPILE([], [], [
++	AC_MSG_RESULT([yes])
++], [
++	AC_MSG_RESULT([no])
++	CFLAGS="$save_CFLAGS"
++])
++
++AC_MSG_CHECKING([whether compiler understands -fno-strength-reduce])
++save_CFLAGS="$CFLAGS"
++CFLAGS="$CFLAGS -fno-strength-reduce"
++AC_TRY_COMPILE([], [], [
++	AC_MSG_RESULT([yes])
++], [
++	AC_MSG_RESULT([no])
++	CFLAGS="$save_CFLAGS"
++])
++
++# Checks for library functions.
++
++# Write the output.
++AC_SUBST([BZIP2_LT_CURRENT])
++AC_SUBST([BZIP2_LT_REVISION])
++AC_SUBST([BZIP2_LT_AGE])
++AC_CONFIG_FILES([Makefile bzip2.pc])
++AC_OUTPUT
diff --git a/recipes/bzip2/bzip2.inc b/recipes/bzip2/bzip2.inc
index e11ab73..e890429 100644
--- a/recipes/bzip2/bzip2.inc
+++ b/recipes/bzip2/bzip2.inc
@@ -2,7 +2,7 @@ DESCRIPTION = "Very high-quality data compression program"
 
 RECIPE_TYPES = "machine native sdk"
 
-inherit autotools pkgconfig
+inherit autotools-autoreconf pkgconfig
 
 SRC_URI = "http://www.bzip.org/${PV}/bzip2-${PV}.tar.gz"
 
@@ -35,7 +35,9 @@ RDEPENDS_${PN}-bzgrep = "${PN}-libbz2"
 RDEPENDS_${PN}-bzip2recover = "${PN}-libbz2"
 RDEPENDS_${PN}-bzmore = "${PN}-libbz2"
 
-do_configure () {
+do_autoreconf () {
+    if [ -d "${pkgltdldir}" ] ; then
+        export _lt_pkgdatadir="${pkgltdldir}"
+    fi
     bash ./autogen.sh
-    do_configure_autotools
 }