diff --git a/recipes/glib/glib-2.34.0.inc b/recipes/glib/glib-2.34.0.inc
index 7399667..ceabb89 100644
--- a/recipes/glib/glib-2.34.0.inc
+++ b/recipes/glib/glib-2.34.0.inc
@@ -1,2 +1,2 @@
-DEPENDS_${PN}-libglib += "${DEPENDS_THREADS}"
-DEPENDS_${PN}-libgmodule += "${DEPENDS_THREADS}"
+DEPENDS_${PN}-libglib-2.0 += "${DEPENDS_THREADS}"
+DEPENDS_${PN}-libgmodule-2.0 += "${DEPENDS_THREADS}"
diff --git a/recipes/glib/glib-common.inc b/recipes/glib/glib-common.inc
index 9815130..50ce797 100644
--- a/recipes/glib/glib-common.inc
+++ b/recipes/glib/glib-common.inc
@@ -9,7 +9,8 @@ inherit c++ autotools
 DEPENDS = "host-cross:gtk-doc libz libffi libelf"
 
 DEPENDS += "${DEPENDS_NATIVE}"
-DEPENDS_NATIVE = "native:libglib native:libgthread native:libgmodule native:glib-utils"
+DEPENDS_NATIVE = "native:libglib-2.0 native:libgthread-2.0 \
+		native:libgmodule-2.0 native:glib-utils"
 DEPENDS_NATIVE:native = ""
 
 DEPENDS += "${DEPENDS_LIBDL}"
@@ -55,8 +56,7 @@ FILES_${PN}-doc += "${datadir}/gtk-doc"
 FILES_${PN}-dev += "${datadir}/glib-2.0 ${libdir}/gdbus-2.0"
 
 inherit auto-package-libs
-AUTO_PACKAGE_LIBS = "glib gobject gmodule gthread gio"
-AUTO_PACKAGE_LIBS_LIBDIR = "${libdir}:lib:-2.0"
+AUTO_PACKAGE_LIBS = "glib-2.0 gobject-2.0 gmodule-2.0 gthread-2.0 gio-2.0"
 AUTO_PACKAGE_LIBS_RDEPENDS = "${PN}"
 AUTO_PACKAGE_LIBS_DEV_DEPENDS = "${PN}-dev_${PV}"
 AUTO_PACKAGE_LIBS_DEV_RDEPENDS = "${PN}-dev_${PV}"
@@ -67,15 +67,44 @@ DEPENDS_FAM = ""
 DEPENDS_PCRE = ""
 
 DEPENDS_${PN} += "libffi"
-DEPENDS_${PN}-utils += "${PN}-libgio"
-DEPENDS_${PN}-libglib += "libc libgcc ${DEPENDS_PCRE} ${DEPENDS_LIBDL} ${DEPENDS_LIBINTL} ${DEPENDS_LIBRESOLV}"
-DEPENDS_${PN}-libgthread += "libc libglib ${DEPENDS_THREADS} ${DEPENDS_PCRE}"
-DEPENDS_${PN}-libgobject += "libc libgcc libffi libglib libgthread ${DEPENDS_THREADS} ${DEPENDS_PCRE}"
-DEPENDS_${PN}-libgmodule += "libc ${DEPENDS_LIBDL} libglib ${DEPENDS_PCRE}"
-DEPENDS_${PN}-libgio += "libc libgcc ${DEPENDS_LIBDL} ${DEPENDS_LIBRESOLV} libz libffi libglib libgmodule libgobject libgthread ${DEPENDS_PCRE} ${DEPENDS_THREADS}"
-
-FILES_${PN}-libgio-dev = "${libdir}/pkgconfig/gio-*-2.0.pc"
-FILES_${PN}-libgmodule-dev = "${libdir}/pkgconfig/gmodule-*-2.0.pc"
+DEPENDS_${PN}-utils += "libgio-2.0 libglib-2.0 libgmodule-2.0 libgobject-2.0 \
+				libelf"
+RDEPENDS_GLIB_UTILS = "libc libdl libffi libgio-2.0 libgmodule-2.0 \
+			libgoject-2.0 libpcre libpthread libresolv libz"
+RDEPENDS_GLIB_UTILS:native = ""
+RDEPENDS_${PN}-utils = "${RDEPENDS_GLIB_UTILS}"
+DEPENDS_${PN}-libglib-2.0 += "libc libgcc ${DEPENDS_PCRE} ${DEPENDS_LIBDL} \
+				${DEPENDS_LIBINTL} ${DEPENDS_LIBRESOLV} \
+				${DEPENDS_THREADS}"
+DEPENDS_${PN}-libgthread-2.0 += "libc ${DEPENDS_THREADS} ${DEPENDS_PCRE} \
+				libglib-2.0"
+DEPENDS_${PN}-libgobject-2.0 += "libc libgcc libffi libgthread-2.0 \
+				${DEPENDS_THREADS} ${DEPENDS_PCRE} \
+				libglib-2.0"
+DEPENDS_${PN}-libgmodule-2.0 += "libc ${DEPENDS_LIBDL} ${DEPENDS_PCRE} \
+				libglib-2.0 ${DEPENDS_THREADS}"
+DEPENDS_${PN}-libgio-2.0 += "libc libgcc ${DEPENDS_LIBDL} ${DEPENDS_LIBRESOLV} \
+				libz libffi libglib-2.0 libgmodule-2.0 \
+				libgobject-2.0 libgthread-2.0 ${DEPENDS_PCRE} \
+				${DEPENDS_THREADS}"
+
+FILES_${PN}-libgio-2.0-dev += "${libdir}/pkgconfig/gio-*-2.0.pc"
+FILES_${PN}-libgmodule-2.0-dev += "${libdir}/pkgconfig/gmodule-*-2.0.pc"
 FILES_${PN} += "${libdir}/charset.alias"
 
-include glib-${PV}.inc
+#To be removed in next base master release!
+PROVIDES_${PN}-libglib-2.0 += "libglib"
+PROVIDES_${PN}-libglib-2.0-dev += "libglib-dev"
+PROVIDES_${PN}-libglib-2.0[qa] += "allow-missing-soname:libglib"
+PROVIDES_${PN}-libgobject-2.0 += "libgobject"
+PROVIDES_${PN}-libgobject-2.0-dev += "libgobject-dev"
+PROVIDES_${PN}-libgobject-2.0[qa] += "allow-missing-soname:libgobject"
+PROVIDES_${PN}-libgmodule-2.0 += "libgmodule"
+PROVIDES_${PN}-libgmodule-2.0-dev += "libgmodule-dev"
+PROVIDES_${PN}-libgmodule-2.0[qa] += "allow-missing-soname:libgmodule"
+PROVIDES_${PN}-libgthread-2.0 += "libgthread"
+PROVIDES_${PN}-libgthread-2.0-dev += "libgthread-dev"
+PROVIDES_${PN}-libgthread-2.0[qa] += "allow-missing-soname:libgthread"
+PROVIDES_${PN}-libgio-2.0 += "libgio"
+PROVIDES_${PN}-libgio-2.0-dev += "libgio-dev"
+PROVIDES_${PN}-libgio-2.0[qa] += "allow-missing-soname:libgio"