diff --git a/recipes/libffi/libffi-3.0.13/ax_enable_builddir.patch b/recipes/libffi/libffi-3.0.13/ax_enable_builddir.patch
new file mode 100644
index 0000000..2d3956b
--- /dev/null
+++ b/recipes/libffi/libffi-3.0.13/ax_enable_builddir.patch
@@ -0,0 +1,22 @@
+--- libffi-3.0.13/configure.orig	2013-12-19 11:35:04.442027429 +0100
++++ libffi-3.0.13/configure	2013-12-19 11:35:51.786026030 +0100
+@@ -2751,7 +2751,7 @@
+       { $as_echo "$as_me:${as_lineno-$LINENO}: result: ....exec $SHELL $srcdir/$0 \"--srcdir=$srcdir\" \"--enable-builddir=$ax_enable_builddir\" ${1+\"$@\"}" >&5
+ $as_echo "....exec $SHELL $srcdir/$0 \"--srcdir=$srcdir\" \"--enable-builddir=$ax_enable_builddir\" ${1+\"$@\"}" >&6; }
+       case "$0" in # restart
+-       /\\*) eval $SHELL "'$0'" "'--srcdir=$srcdir'" "'--enable-builddir=$ax_enable_builddir'" $ac_configure_args ;;
++       [/\\]*) eval $SHELL "'$0'" "'--srcdir=$srcdir'" "'--enable-builddir=$ax_enable_builddir'" $ac_configure_args ;;
+        *) eval $SHELL "'$srcdir/$0'" "'--srcdir=$srcdir'" "'--enable-builddir=$ax_enable_builddir'" $ac_configure_args ;;
+       esac ; exit $?
+     fi
+--- libffi-3.0.13/m4/ax_enable_builddir.m4.orig	2013-12-19 11:36:07.802025557 +0100
++++ libffi-3.0.13/m4/ax_enable_builddir.m4	2013-12-19 11:36:35.738024731 +0100
+@@ -121,7 +121,7 @@
+       test -f $srcdir/$cache_file  && mv $srcdir/$cache_file  .
+       AC_MSG_RESULT(....exec $SHELL $srcdir/[$]0 "--srcdir=$srcdir" "--enable-builddir=$SUB" ${1+"[$]@"})
+       case "[$]0" in # restart
+-       [/\\]*) eval $SHELL "'[$]0'" "'--srcdir=$srcdir'" "'--enable-builddir=$SUB'" $ac_configure_args ;;
++       [[/\\]]*) eval $SHELL "'[$]0'" "'--srcdir=$srcdir'" "'--enable-builddir=$SUB'" $ac_configure_args ;;
+        *) eval $SHELL "'$srcdir/[$]0'" "'--srcdir=$srcdir'" "'--enable-builddir=$SUB'" $ac_configure_args ;;
+       esac ; exit $?
+     fi
diff --git a/recipes/libffi/libffi-3.0.13/configure-no-multiosdir.patch b/recipes/libffi/libffi-3.0.13/configure-no-multiosdir.patch
new file mode 100644
index 0000000..7983abe
--- /dev/null
+++ b/recipes/libffi/libffi-3.0.13/configure-no-multiosdir.patch
@@ -0,0 +1,38 @@
+--- libffi-3.0.13/configure.ac.orig	2013-12-19 11:29:01.658038148 +0100
++++ libffi-3.0.13/configure.ac	2013-12-19 11:29:49.070036747 +0100
+@@ -546,11 +546,11 @@
+     toolexecdir='$(libdir)/gcc-lib/$(target_alias)'
+     toolexeclibdir='$(libdir)'
+   fi
+-  multi_os_directory=`$CC -print-multi-os-directory`
+-  case $multi_os_directory in
+-    .) ;; # Avoid trailing /.
+-    ../*) toolexeclibdir=$toolexeclibdir/$multi_os_directory ;;
+-  esac
++  #multi_os_directory=`$CC -print-multi-os-directory`
++  #case $multi_os_directory in
++  #  .) ;; # Avoid trailing /.
++  #  ../*) toolexeclibdir=$toolexeclibdir/$multi_os_directory ;;
++  #esac
+   AC_SUBST(toolexecdir)
+ else
+   toolexeclibdir='$(libdir)'
+--- libffi-3.0.13/configure.orig	2013-12-19 11:28:50.710038471 +0100
++++ libffi-3.0.13/configure	2013-12-19 11:29:36.738037111 +0100
+@@ -14840,11 +14840,11 @@
+     toolexecdir='$(libdir)/gcc-lib/$(target_alias)'
+     toolexeclibdir='$(libdir)'
+   fi
+-  multi_os_directory=`$CC -print-multi-os-directory`
+-  case $multi_os_directory in
+-    .) ;; # Avoid trailing /.
+-    ../*) toolexeclibdir=$toolexeclibdir/$multi_os_directory ;;
+-  esac
++  #multi_os_directory=`$CC -print-multi-os-directory`
++  #case $multi_os_directory in
++  #  .) ;; # Avoid trailing /.
++  #  ../*) toolexeclibdir=$toolexeclibdir/$multi_os_directory ;;
++  #esac
+ 
+ else
+   toolexeclibdir='$(libdir)'
diff --git a/recipes/libffi/libffi_3.0.13.oe b/recipes/libffi/libffi_3.0.13.oe
new file mode 100644
index 0000000..8f0859f
--- /dev/null
+++ b/recipes/libffi/libffi_3.0.13.oe
@@ -0,0 +1,9 @@
+# -*- mode:python; -*-
+require ${PN}.inc
+
+LICENSE = "MIT"
+
+SRC_URI += "file://ax_enable_builddir.patch"
+SRC_URI += "file://configure-no-multiosdir.patch"
+
+LIBRARY_VERSION = "6"
diff --git a/recipes/libffi/libffi_3.0.13.oe.sig b/recipes/libffi/libffi_3.0.13.oe.sig
new file mode 100644
index 0000000..4fc8a3a
--- /dev/null
+++ b/recipes/libffi/libffi_3.0.13.oe.sig
@@ -0,0 +1 @@
+f5230890dc0be42fb5c58fbf793da253155de106  libffi-3.0.13.tar.gz